#include "stdafx.h"
#include "InstallBkBsfilWrapper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

////////////////////////////////////////////////////////////////////////
// BkBsfilWrapper ̃ZbgAbvvON
////////////////////////////////////////////////////////////////////////

BEGIN_MESSAGE_MAP(CInstallBkBsfilWrapperApp, CWinApp)
//	ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()

//----------------------------------------------------------------------
// RXgN^
//----------------------------------------------------------------------

CInstallBkBsfilWrapperApp::CInstallBkBsfilWrapperApp()
{
}

//----------------------------------------------------------------------
// CInstallBkBsfilWrapperApp IuWFNg̏s
//----------------------------------------------------------------------

BOOL CInstallBkBsfilWrapperApp::InitInstance()
{
	CWinApp::InitInstance();

	const CHAR* setupProgramName = "bkpiinst.exe";	// ZbgAbvvO
	const CHAR* setupParameter = "BkBsfilWrapper";	// ZbgAbvvOւ̃p[^

	const CHAR* requiredFilenames[] = {
		setupProgramName,			// ZbgAbvvO
		"BkBsfilWrapper.inf",	// ZbgAbvvOp[^t@C
		"BkBsfilWrapperSc.inf",	// ZbgAbvvOp[^t@C(XNvgp)
		"BkBsfilWrapper.dll",	// vOCW[
	};
	const CHAR* pluginFolderName = "BkBsfilWrapper";	// [J̃vOCtH_

	// vOCtH_ɕKvɂȂ郂W[
	CStringList requiredPrograms;
	requiredPrograms.AddTail("iconv.dll");

	CString msg;
	DWORD attr;
	BOOL rc;

	//
	// bsfilter.exe  bsfilter XNvĝǂgq˂
	//

	int selbsfilter = AfxMessageBox("bsfilter.exe  bsfilter XNvĝǂgp܂HB\r\n\r\nbsfilter.exe gpꍇ́u͂vA\r\nbsfilter XNvggpꍇ́uvIłB\r\n\r\nbsfilter XNvggpꍇACXg[ɃvOC̐ݒ肪KvłB", MB_YESNO | MB_ICONINFORMATION);
	if (selbsfilter == IDYES) {
		requiredPrograms.AddHead("bsfilter.exe");
		setupParameter = "BkBsfilWrapper";
	} else {
		requiredPrograms.AddHead("bsfilter");
		setupParameter = "BkBsfilWrapperSc";
	}


	//
	// {vȎ݂fBNg𓾂āAJgfBNgɐݒ肷B
	//
	CHAR modulePath[MAX_PATH * 10];
	DWORD pathLength = GetModuleFileName(AfxGetInstanceHandle(), modulePath, sizeof(modulePath));
	modulePath[pathLength] = '\0';
	CHAR *wp = strrchr(modulePath, '\\');
	if (wp) {
		*wp = '\0';
	}
	CString currentDirectory = modulePath;

	SetCurrentDirectory(currentDirectory);

	//
	// ZbgAbvɕKvȃt@C݂邩mF
	//
	for (int i = 0; i < sizeof(requiredFilenames)/sizeof(CHAR*); ++i) {

		CString localFilepath;
		localFilepath.Format("%s\\%s", currentDirectory, requiredFilenames[i]);

		attr = GetFileAttributes(localFilepath);
		if (attr == (DWORD) -1 || (attr & FILE_ATTRIBUTE_DIRECTORY)) {
			msg.Format("t@C %s ݂܂Bt@CmFĂēxsĂB", requiredFilenames[i]);
			AfxMessageBox(msg, MB_OK | MB_ICONERROR);
			return FALSE;
		}
	}

	//
	// [J̃vOCtH_݂邩mF
	//
	CString pluginFolderpath;
	pluginFolderpath.Format("%s\\%s", currentDirectory, pluginFolderName);
	attr = GetFileAttributes(pluginFolderpath);
	if (attr == (DWORD) -1 || !(attr & FILE_ATTRIBUTE_DIRECTORY)) {

		// 쐬
		rc = CreateDirectory(pluginFolderpath, 0);
		if (!rc) {
			msg.Format("JgfBNgɃtH_ %s 쐬ł܂BƂō쐬ĂēxsĂB", pluginFolderName);
			AfxMessageBox(msg, MB_OK | MB_ICONERROR);
			return FALSE;
		}
	}

	//
	// KvȃW[[J̃vOCtH_ɑ݂邩`FbN
	//
	for (int i = 0; i < requiredPrograms.GetSize(); ++i) {

		POSITION pos = requiredPrograms.FindIndex(i);

		CString localModuleFilepath;
		localModuleFilepath.Format("%s\\%s\\%s", currentDirectory, pluginFolderName, requiredPrograms.GetAt(pos));

		attr = GetFileAttributes(localModuleFilepath);
		if (attr != (DWORD) -1 && !(attr & FILE_ATTRIBUTE_DIRECTORY)) {
			// OK: ݂
			continue;
		}

		// t@C݂Ȃꍇ́A[U[Ɏw肳ă[J̃vOCtH_ɃRs[
		CWnd* pDesktopWnd = CWnd::FromHandle(GetDesktopWindow());

		CString moduleFilepath;
		CString moduleFilename;
		CString title;

		title.Format("%s w肵ĂB", requiredPrograms.GetAt(pos));
		
		int compRc = -1;
		do {
			rc = SelectFilepath(pDesktopWnd, title, requiredPrograms.GetAt(pos), moduleFilepath, moduleFilename);
			if (!rc) {
				msg.Format("%s 擾ł܂Bt@CmFĂēxsĂB", requiredPrograms.GetAt(pos));
				AfxMessageBox(msg, MB_OK | MB_ICONERROR);
				return FALSE;
			}

			compRc = moduleFilename.CompareNoCase(requiredPrograms.GetAt(pos));
			if (compRc != 0) {
				msg.Format("t@CႢ܂B%s w肵ĂB", requiredPrograms.GetAt(pos));
				AfxMessageBox(msg, MB_OK | MB_ICONERROR);
			}

		} while (compRc != 0);

		rc = CopyFile(moduleFilepath, localModuleFilepath, FALSE);
		if (!rc) {
			msg.Format("%s  %s ɃRs[ł܂B蓮ŃRs[ĂēxsĂB", moduleFilepath, localModuleFilepath);
			AfxMessageBox(msg, MB_OK | MB_ICONERROR);
			return FALSE;
		}
	}

	//
	// ZbgAbvvON
	//
	CString commandLine;

	commandLine.Format("%s %s", setupProgramName, setupParameter);

	STARTUPINFO si;
	PROCESS_INFORMATION pi;

	memset(&si, 0, sizeof(si));
	si.cb = sizeof(si);
	memset(&pi, 0, sizeof(pi));

	rc = CreateProcess(
						0, (LPSTR) LPCTSTR(commandLine),
						0, 0,
						FALSE,
						CREATE_DEFAULT_ERROR_MODE | CREATE_NEW_CONSOLE | CREATE_NEW_PROCESS_GROUP,
						0, LPCTSTR(currentDirectory),
						&si, &pi
					);
	if (rc) {
		CloseHandle(pi.hProcess);
		CloseHandle(pi.hThread);
	} else {
		msg.Format("R}hC %s sł܂B", commandLine);
		AfxMessageBox(msg, MB_OK | MB_ICONERROR);
	}

	return TRUE;
}

//----------------------------------------------------------------------
// [U[Ƀt@CI
//----------------------------------------------------------------------

BOOL CInstallBkBsfilWrapperApp::SelectFilepath(CWnd* pWnd, const CHAR* title, const CHAR* filename, CString& resultFilepath, CString& resultFilename)
{
	CHAR myDocFolder[MAX_PATH * 10];

	CFileDialog fileDlg(TRUE, 0, filename, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_NOCHANGEDIR | OFN_PATHMUSTEXIST, "ׂẴt@C (*.*)|*.*||", pWnd);
	HRESULT hr = SHGetFolderPath(pWnd->GetSafeHwnd(), CSIDL_PERSONAL, 0, SHGFP_TYPE_CURRENT, myDocFolder);
	if (SUCCEEDED(hr)) {
		fileDlg.m_ofn.lpstrInitialDir = myDocFolder;
	}

	fileDlg.m_ofn.lpstrTitle = title;

	int drc = fileDlg.DoModal();
	if (drc != IDOK) {
		return FALSE;
	}

	resultFilepath = fileDlg.GetPathName();
	resultFilename = fileDlg.GetFileName();

	return TRUE;
}

////////////////////////////////////////////////////////////////////////
// CInstallBkBsfilWrapperApp IuWFNg
////////////////////////////////////////////////////////////////////////

CInstallBkBsfilWrapperApp theApp;


